return function(button_list)
	local ret= {}
	local rots= {Left= 90, Down= 0, Up= 180, Right= 270}
	for i, button in ipairs(button_list) do
		ret[i]= Def.Sprite{
			Texture= "explore", InitCommand= function(self)
				self:rotationz(rots[button] or 0)
					:draworder(newfield_draw_order.explosion)
					:diffusealpha(0)
			end,
			WidthSetCommand= function(self, param)
				param.column:set_layer_fade_type(self, "FieldLayerFadeType_Explosion")
			end,
			ColumnJudgmentCommand= function(self, param)
				local diffuse= {
					TapNoteScore_W1= {1, 1, 1, 1},
					TapNoteScore_W2= {1, 1, .3, 1},
					TapNoteScore_W3= {0, 1, .4, 1},
					TapNoteScore_W4= {.3, .8, 1, 1},
					TapNoteScore_W5= {.8, 0, .6, 1},
				}
				local exp_color= diffuse[param.tap_note_score or param.hold_note_score]
				if exp_color then
					-- The hide at the end is queued so that if the notefield applies
					-- glow to the explosion, it will still disappear at then end.
					self:stoptweening()
						:diffuse(exp_color):zoom(2):diffusealpha(1)
						:linear(0.2):zoom(.25):diffusealpha(.3)
						:linear(0.06):diffusealpha(0)
				end
			end,
		}
	end
	return ret
end
