return function(button_list)
	local rots= {Left= 90, Down= 0, Up= 180, Right= 270}
	local tap_states= NewSkin.generic_state_map(1, {1, 2, 3, 4, 6, 8, 12, 16})
	local mine_states= NewSkin.single_quanta_state_map{1}
	local hold_states= NewSkin.single_quanta_state_map{1}
	local hold_len= {
		start_note_offset= -9/64,
		end_note_offset= 9/64,
		head_pixs= 9,
		body_pixs= 7,
		tail_pixs= 9,
	}
	local function hold(tex)
		return {
			{state_map= hold_states, textures= {tex}, length_data= hold_len},
			{state_map= hold_states, textures= {tex}, length_data= hold_len},
		}
	end
	local holds= {
		TapNoteSubType_Hold= hold("hold"),
		TapNoteSubType_Roll= hold("roll"),
	}
	local columns= {}
	for i, button in ipairs(button_list) do
		columns[i]= {
			hold_gray_percent= .25,
			taps= {
				NewSkinTapPart_Tap= {
					state_map= tap_states,
					actor= Def.Sprite{
						Texture= "taps",
						InitCommand= function(self) self:rotationz(rots[button]):glow{1, 1, 1, .25} end}},
				NewSkinTapPart_Mine= {
					state_map= mine_states,
					actor= Def.Sprite{Texture= "mine"}},
				NewSkinTapPart_Lift= {
					state_map= tap_states,
					actor= Def.Sprite{
						Texture= "lifts",
						InitCommand= function(self) self:rotationz(rots[button]) end}},
			},
			holds= holds, reverse_holds= holds,
		}
	end
	return {columns= columns}
end
